import { _ as _sliced_to_array } from "@swc/helpers/_/_sliced_to_array";
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { serializeJson } from "@modern-js/runtime-utils/node";
import { Await, useAsyncError } from "@modern-js/runtime-utils/router";
import { Suspense, useEffect, useMemo, useRef } from "react";
import { ROUTER_DATA_JSON_ID } from "../../core/constants";
import { defineRunInlineAndRouterDataInit, initRouterDataAttrs, runRouterDataFnStr, runWindowFnStr } from "./constants";
import { serializeErrors } from "./utils";
var DeferredDataScripts = function(props) {
  var staticContext = props === null || props === void 0 ? void 0 : props.context;
  var inlineScript = props === null || props === void 0 ? void 0 : props.inlineScript;
  var hydratedRef = useRef(false);
  useEffect(function() {
    hydratedRef.current = true;
  }, []);
  var deferredScripts = useMemo(function() {
    if (!staticContext) {
      return null;
    }
    var activeDeferreds = staticContext.activeDeferreds || [];
    var _ROUTER_DATA = {
      loaderData: staticContext.loaderData,
      errors: serializeErrors(staticContext.errors)
    };
    var initialScript0 = defineRunInlineAndRouterDataInit;
    var initialScript1 = inlineScript ? "" : "".concat(serializeJson(_ROUTER_DATA));
    var initialScript2 = {
      fnName: "initRouterData",
      fnArgs: [
        ROUTER_DATA_JSON_ID
      ],
      fnRun: runWindowFnStr,
      fnScriptSrc: "modern-run-window-fn"
    };
    var initialScript3 = initRouterDataAttrs;
    var deferredDataScripts = [];
    var initialScripts = Object.entries(activeDeferreds).map(function(param) {
      var _param = _sliced_to_array(param, 2), routeId = _param[0], deferredData = _param[1];
      var pendingKeys = new Set(deferredData.pendingKeys);
      var deferredKeys = deferredData.deferredKeys;
      var deferredKeyPromiseManifests = deferredKeys.map(function(key) {
        if (pendingKeys.has(key)) {
          deferredDataScripts.push(/* @__PURE__ */ _jsx(DeferredDataScript, {
            nonce: props === null || props === void 0 ? void 0 : props.nonce,
            data: deferredData.data[key],
            dataKey: key,
            routeId
          }, "".concat(routeId, " | ").concat(key)));
          return {
            key,
            routerDataFnName: "s",
            routerDataFnArgs: [
              routeId,
              key
            ]
          };
        } else {
          var trackedPromise = deferredData.data[key];
          if (typeof trackedPromise._error !== "undefined") {
            var error = {
              message: trackedPromise._error.message,
              stack: process.env.NODE_ENV !== "production" ? trackedPromise._error.stack : void 0
            };
            return {
              key,
              routerDataFnName: "p",
              routerDataFnArgs: [
                void 0,
                serializeJson(error)
              ]
            };
          } else {
            if (typeof trackedPromise._data === "undefined") {
              throw new Error("The deferred data for ".concat(key, " was not resolved, did you forget to return data from a deferred promise"));
            }
            return {
              key,
              routerDataFnName: "p",
              routerDataFnArgs: [
                serializeJson(trackedPromise._data)
              ]
            };
          }
        }
      });
      return {
        fnName: "mergeData",
        fnRun: runWindowFnStr,
        fnArgs: [
          routeId,
          deferredKeyPromiseManifests
        ],
        fnScriptSrc: "modern-run-window-fn"
      };
    });
    return [
      initialScript0,
      initialScript1,
      initialScript2,
      initialScript3,
      initialScripts,
      deferredDataScripts
    ];
  }, []);
  if (!deferredScripts) {
    return null;
  }
  return /* @__PURE__ */ _jsxs(_Fragment, {
    children: [
      !hydratedRef.current && /* @__PURE__ */ _jsxs(_Fragment, {
        children: [
          /* @__PURE__ */ _jsx("script", {
            async: true,
            nonce: props === null || props === void 0 ? void 0 : props.nonce,
            "data-script-src": "modern-define-init",
            suppressHydrationWarning: true,
            dangerouslySetInnerHTML: {
              __html: deferredScripts[0]
            }
          }),
          deferredScripts[1].length !== 0 && /* @__PURE__ */ _jsx("script", {
            type: "application/json",
            id: ROUTER_DATA_JSON_ID,
            nonce: props === null || props === void 0 ? void 0 : props.nonce,
            suppressHydrationWarning: true,
            dangerouslySetInnerHTML: {
              __html: deferredScripts[1]
            }
          }),
          /* @__PURE__ */ _jsx("script", {
            async: true,
            nonce: props === null || props === void 0 ? void 0 : props.nonce,
            "data-script-src": deferredScripts[2].fnScriptSrc,
            "data-fn-name": deferredScripts[2].fnName,
            "data-fn-args": JSON.stringify(deferredScripts[2].fnArgs),
            suppressHydrationWarning: true,
            dangerouslySetInnerHTML: {
              __html: deferredScripts[2].fnRun
            }
          }),
          /* @__PURE__ */ _jsx("script", {
            async: true,
            nonce: props === null || props === void 0 ? void 0 : props.nonce,
            "data-script-src": "router-data-attr-init-inline",
            suppressHydrationWarning: true,
            dangerouslySetInnerHTML: {
              __html: deferredScripts[3]
            }
          }),
          deferredScripts[4].map(function(param) {
            var fnName = param.fnName, fnRun = param.fnRun, fnArgs = param.fnArgs, fnScriptSrc = param.fnScriptSrc;
            return /* @__PURE__ */ _jsx("script", {
              async: true,
              "data-script-src": fnScriptSrc,
              "data-fn-name": fnName,
              "data-fn-args": JSON.stringify(fnArgs),
              nonce: props === null || props === void 0 ? void 0 : props.nonce,
              suppressHydrationWarning: true,
              dangerouslySetInnerHTML: {
                __html: fnRun
              }
            }, fnName);
          })
        ]
      }),
      !hydratedRef.current && deferredScripts[5]
    ]
  });
};
var DeferredDataScript = function(param) {
  var data = param.data, routeId = param.routeId, dataKey = param.dataKey, nonce = param.nonce;
  return /* @__PURE__ */ _jsx(Suspense, {
    children: typeof document === "undefined" && data && dataKey && routeId ? /* @__PURE__ */ _jsx(Await, {
      resolve: data,
      errorElement: /* @__PURE__ */ _jsx(ErrorDeferredDataScript, {
        routeId,
        dataKey,
        nonce
      }),
      children: function(data2) {
        return /* @__PURE__ */ _jsx("script", {
          async: true,
          nonce,
          "data-fn-name": "r",
          "data-script-src": "modern-run-router-data-fn",
          "data-fn-args": "".concat(JSON.stringify([
            routeId,
            dataKey,
            data2
          ])),
          suppressHydrationWarning: true,
          dangerouslySetInnerHTML: {
            __html: runRouterDataFnStr
          }
        });
      }
    }) : null
  });
};
var ErrorDeferredDataScript = function(param) {
  var routeId = param.routeId, dataKey = param.dataKey, nonce = param.nonce;
  var error = useAsyncError();
  return /* @__PURE__ */ _jsx("script", {
    nonce,
    suppressHydrationWarning: true,
    dangerouslySetInnerHTML: {
      __html: "_ROUTER_DATA.r(".concat(JSON.stringify(routeId), ", ").concat(JSON.stringify(dataKey), ", ").concat(void 0, ", ").concat(serializeJson({
        message: error.message,
        stack: error.stack
      }), ");")
    }
  });
};
var DeferredDataScripts_node_default = DeferredDataScripts;
export {
  DeferredDataScripts_node_default as default
};
